﻿Imports System.Diagnostics
Imports System.Windows.Forms

Public Class MainFrame

    '*************************************************************
    ' WIN32関連
    '*************************************************************

    Private Structure POINTAPI
        Dim x As Integer
        Dim y As Integer
    End Structure

    Private Declare Function GetCursorPos Lib "user32" (ByRef lpPoint As POINTAPI) As Integer
    Private Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Integer, ByRef lpPoint As POINTAPI) As Integer

    '*************************************************************
    ' 定数定義
    '*************************************************************

    Public Const g_cstTITLE As String = "FAX情報表示" 'メッセージボックスのタイトル用

    Public Const TREE_SELECT_TYPE_LOG As Short = 0
    Public Const TREE_SELECT_TYPE_SEND_BEFORE As Short = 1
    Public Const TREE_SELECT_TYPE_SEND_AFTER As Short = 2
    Public Const TREE_SELECT_TYPE_RECEIVE As Short = 3

    Const s_cstMouseClickMode_Non As Short = 100
    Const s_cstMouseClickMode_RightClick As Short = 300

    '*************************************************************
    ' 変数定義
    '*************************************************************

    Dim s_bPgmRun As Boolean ' プログラム起動フラグ

    Dim s_iMouseClickMode As Short ' マウス状態
    Dim s_bListViewSort As Boolean ' リストビューソートフラグ

    '*************************************************************
    ' プログラム起動
    '*************************************************************

    Private Sub MainFrame_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        '-------------------------------------------------------------
        ' プログラム起動フラグリセット

        s_bPgmRun = False

        '-------------------------------------------------------------
        ' プログラムの２重起動不可

        If (UBound(Diagnostics.Process.GetProcessesByName(Diagnostics.Process.GetCurrentProcess.ProcessName)) > 0) Then
            MsgBox("すでに「" & g_cstTITLE & "」は起動されています。", MsgBoxStyle.Critical, g_cstTITLE)
            Me.Close()
            End
        End If

        '/////////////////////////////////////////////////////////////
        '// STARFAX インストール確認

        If AxSFCSEnv1.CheckInstall() <> SFCSENV_SUCCESS Then
            MsgBox("STARFAX がインストールされていない、" & vbCrLf & "もしくは STARFAX 環境設定プログラム でフォルダ環境が設定されていません。", MsgBoxStyle.Critical, g_cstTITLE)
            Me.Close()
            End
        End If

        '/////////////////////////////////////////////////////////////
        '// STARFAX サブフォルダ確認

        ' 受信情報フォルダ
        If AxSFCSEnv1.CheckSubFolder(SFCSENV_SMODE_RECVINFO) <> SFCSENV_SUCCESS Then
            MsgBox("受信情報フォルダが存在しません。" & vbCrLf & "nSTARFAX を１度起動することにより、" & vbCrLf & "受信情報フォルダが作成されます。", MsgBoxStyle.Critical, g_cstTITLE)
            Me.Close()
            End
        End If
        ' 送信情報フォルダ
        If AxSFCSEnv1.CheckSubFolder(SFCSENV_SMODE_SENDINFO) <> SFCSENV_SUCCESS Then
            MsgBox("送信情報フォルダが存在しません。" & vbCrLf & "STARFAX を１度起動することにより、" & vbCrLf & "送信情報フォルダが作成されます。", MsgBoxStyle.Critical, g_cstTITLE)
            Me.Close()
            End
        End If
        ' 未送信情報フォルダ
        If AxSFCSEnv1.CheckSubFolder(SFCSENV_SMODE_QUEINFO) <> SFCSENV_SUCCESS Then
            MsgBox("未送信情報フォルダが存在しません。" & vbCrLf & "STARFAX を１度起動することにより、" & vbCrLf & "未送信情報フォルダが作成されます。", MsgBoxStyle.Critical, g_cstTITLE)
            Me.Close()
            End
        End If

        ' 受信情報削除命令フォルダ
        If AxSFCSEnv1.CheckSubFolder(SFCSENV_SMODE_RECVDELMIS) <> SFCSENV_SUCCESS Then
            MsgBox("受信情報削除命令フォルダが存在しません。" & vbCrLf & "STARFAX を１度起動することにより、" & vbCrLf & "受信情報削除命令フォルダが作成されます。", MsgBoxStyle.Critical, g_cstTITLE)
            Me.Close()
            End
        End If
        ' 送信情報削除命令フォルダ
        If AxSFCSEnv1.CheckSubFolder(SFCSENV_SMODE_SENDDELMIS) <> SFCSENV_SUCCESS Then
            MsgBox("送信情報削除命令フォルダが存在しません。" & vbCrLf & "STARFAX を１度起動することにより、" & vbCrLf & "送信情報削除命令フォルダが作成されます。", MsgBoxStyle.Critical, g_cstTITLE)
            Me.Close()
            End
        End If
        ' 未送信情報削除命令フォルダ
        If AxSFCSEnv1.CheckSubFolder(SFCSENV_SMODE_QUEDELMIS) <> SFCSENV_SUCCESS Then
            MsgBox("未送信情報削除命令フォルダが存在しません。" & vbCrLf & "STARFAX を１度起動することにより、" & vbCrLf & "未送信情報削除命令フォルダが作成されます。", MsgBoxStyle.Critical, g_cstTITLE)
            Me.Close()
            End
        End If

        '/////////////////////////////////////////////////////////////
        '// STARFAX サービス状態取得

        If AxSFCSEnv1.CheckServiceStatus() = SFCSENV_SERVICE_STOP Then
            MsgBox("STARFAX が動作していないので、" & vbCrLf & "各種削除命令ファイルを作成しても、実際に削除動作は行われません。", MsgBoxStyle.Exclamation, g_cstTITLE)
        End If

        '/////////////////////////////////////////////////////////////
        '// 各種ログの読み込み
        '//
        '// SFCSLogQueコントロール 《 未送信ログの読み込み 》
        '//   Function Load( Dlg As Integer ) as Long
        '//
        '// SFCSLogSendコントロール 《 送信ログの読み込み 》
        '//   Function Load( Dlg As Integer ) as Long
        '//
        '// SFCSLogRecvコントロール 《 受信ログの読み込み 》
        '//   Function Load( Dlg As Integer ) as Long
        '//

        AxSFCSLogQue1.Load(SFCSLOG_Dialog_TRUE)
        AxSFCSLogSned1.Load(SFCSLOG_Dialog_TRUE)
        AxSFCSLogRecv1.Load(SFCSLOG_Dialog_TRUE)

        '-------------------------------------------------------------
        ' プログラム起動

        s_bPgmRun = True

        Me.TreeView.ExpandAll()

    End Sub

    '*************************************************************
    ' プログラム終了
    '*************************************************************

    Private Sub MainFrame_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        '-------------------------------------------------------------
        ' プログラム起動？

        If s_bPgmRun = True Then

            '/////////////////////////////////////////////////////////////
            '// 各種ログの読み込み 終了処理
            '//
            '// SFCSLogQueコントロール 《 未送信ログの読み込み 終了処理 》
            '//   Sub Release()
            '//
            '// SFCSLogSendコントロール 《 送信ログの読み込み 終了処理 》
            '//   Sub Release()
            '//
            '// SFCSLogRecvコントロール 《 受信ログの読み込み 終了処理 》
            '//   Sub Release()
            '//

            AxSFCSLogQue1.Release()
            AxSFCSLogSned1.Release()
            AxSFCSLogRecv1.Release()

        End If

    End Sub

    '*************************************************************
    ' ツリービュー: 項目選択
    '*************************************************************

    Private Sub TreeView_AfterSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles TreeView.AfterSelect

        SetListView(Me.TreeView.SelectedNode.Tag)

    End Sub

    '-------------------------------------------------------------
    ' リストビュー設定 ( ログ )
    '-------------------------------------------------------------

    Public Sub SetLogTypeLit()
        Me.ToolStripStatusLabel.Text = ""
        Me.ListView.Columns.Clear()
        Me.ListView.Columns.Add("名前", 200)
        Dim i As Integer
        For i = 1 To Me.TreeView.SelectedNode.Nodes.Count()
            Me.ListView.Items.Add(Me.TreeView.SelectedNode.Nodes.Item(i - 1).Text, 2)
        Next
    End Sub

    '-------------------------------------------------------------
    ' リストビュー設定 ( 未送信、送信、受信 )
    '-------------------------------------------------------------

    Public Sub InitLogColHeader()
        If (1 < Me.ListView.Columns.Count()) Then
            Exit Sub
        End If

        Me.ListView.Columns.Clear()
        Me.ListView.Columns.Add("通信結果", 8 * 8)   '0
        Me.ListView.Columns.Add("日付", 10 * 8)   '1
        Me.ListView.Columns.Add("時刻", 8 * 8)   '2
        Me.ListView.Columns.Add("回線番号", 8 * 8)   '3
        Me.ListView.Columns.Add("アカウント", 10 * 8)   '4
        Me.ListView.Columns.Add("相手先", 16 * 8)   '5
        Me.ListView.Columns.Add("FAX", 12 * 8)   '6
        Me.ListView.Columns.Add("ファイル名", 16 * 8)   '7
        Me.ListView.Columns.Add("ページ数", 8 * 8)   '8
        Me.ListView.Columns.Add("通信速度", 13 * 8)   '9
        Me.ListView.Columns.Add("通信時間", 8 * 8)   '10
        Me.ListView.Columns.Add("画品質", 8 * 8)   '11
        Me.ListView.Columns.Add("符号化", 6 * 8)   '12
        Me.ListView.Columns.Add("用紙サイズ", 10 * 8)   '13
        Me.ListView.Columns.Add("エラー訂正", 10 * 8)   '14
        Me.ListView.Columns.Add("回線指定", 8 * 8)   '15
        Me.ListView.Columns.Add("優先順位", 8 * 8)   '16
        Me.ListView.Columns.Add("リトライ回数", 12 * 8)   '17
        Me.ListView.Columns.Add("Ｆコード番号", 16 * 8)   '18
        Me.ListView.Columns.Add("パスワード", 16 * 8)   '19
        Me.ListView.Columns.Add("会社名", 16 * 8)   '20
        Me.ListView.Columns.Add("所属名", 16 * 8)   '21
        Me.ListView.Columns.Add("役職名", 16 * 8)   '22
        Me.ListView.Columns.Add("氏名", 16 * 8)   '23
        Me.ListView.Columns.Add("郵便番号", 8 * 8)   '24
        Me.ListView.Columns.Add("住所1", 16 * 8)   '25
        Me.ListView.Columns.Add("住所2", 16 * 8)   '26
        Me.ListView.Columns.Add("電話番号", 12 * 8)   '27
        Me.ListView.Columns.Add("FAX番号", 12 * 8)   '28
        Me.ListView.Columns.Add("敬称", 6 * 8)   '29
        Me.ListView.Columns.Add("ユーザ使用", 16 * 8)   '30
        Me.ListView.Columns.Add("記録位置", 16 * 8)   '31
        Me.ListView.Columns.Add("自局電話番号", 16 * 8)   '32
        Me.ListView.Columns.Add("ジョブID", 18 * 8)   '33

    End Sub

    '-------------------------------------------------------------
    ' リストビュー表示
    '-------------------------------------------------------------

    Public Sub SetListView(ByVal LogType As Short)

        ' ビューアメニュー、削除メニューをDisable

        mnuActionDisable()

        ' 初期化
        Me.ListView.Items.Clear()

        If LogType = TREE_SELECT_TYPE_SEND_BEFORE Then

            ' 未送信ログの表示
            ViewListViewQue()

        ElseIf LogType = TREE_SELECT_TYPE_SEND_AFTER Then

            ' 送信ログの表示
            ViewListViewSend()

        ElseIf LogType = TREE_SELECT_TYPE_RECEIVE Then

            ' 受信ログの表示
            ViewListViewRecv()

        Else
            ' ログが選択されたとき
            SetLogTypeLit()
        End If

    End Sub

    '-------------------------------------------------------------
    ' 未送信ログの表示
    '-------------------------------------------------------------

    Private Sub ViewListViewQue()

        Dim lComStatus As Object
        Dim iImage As Integer
        Dim i As Object

        InitLogColHeader()

        Me.ListView.UseWaitCursor = True

        '-------------------------------------------------------------
        ' ステータスバー表示

        Me.ToolStripStatusLabel.Text = "ログ件数:" & Str(AxSFCSLogQue1.GetRecCount())

        '/////////////////////////////////////////////////////////////
        '// 未送信ログのリスト表示
        '//
        '// SFCSLogQueコントロール 《 未送信ログのレコード数 取得 》
        '//   Function GetRecCount() as Long
        '//

        Dim strWork As String

        strWork = New String(Chr(0), 1025)

        For i = 0 To (AxSFCSLogQue1.GetRecCount() - 1)

            Dim LstItems() As String = {"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""}

            '/////////////////////////////////////////////////////////////
            '// 各項目の取得と表示
            '//
            '// SFCSLogQueコントロール 《 未送信ログのレコード項目 文字列取得 》
            '//   Function GetRecItemString( Rec As Long, Item As Integer,
            '//                              Get As String ) as Long
            '//

            ' 通信結果
            iImage = 5
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Return, strWork) = SFCSLOG_SUCCESS Then

                '/////////////////////////////////////////////////////////////
                '// 通信状態取得
                '//
                '// SFCSLogQueコントロール 《 未送信ログのレコード 通信状態取得 》
                '//   Function GetRecComStatus( Rec As Long,
                '//                             GetStatus As Long ) as Long
                '//

                ' 通信状態
                lComStatus = 0
                If AxSFCSLogQue1.GetRecComStatus(i, lComStatus) = SFCSLOG_SUCCESS Then
                    If lComStatus = 1 Then
                        iImage = 6
                        LstItems.SetValue(strWork, 0)
                    End If
                End If
                If lComStatus <> 1 Then
                    If strWork = "0" Then
                        iImage = 5
                        LstItems.SetValue("0", 0)
                    Else
                        iImage = 4
                        LstItems.SetValue(strWork, 0)
                    End If
                End If
            End If

            ' 日付/時刻
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Date, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 1)
            End If
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Time, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 2)
            End If

            ' 回線番号
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Line, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 3)
            End If

            ' アカウント
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Acount, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 4)
            End If

            ' 相手先
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_SendName, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 5)
            End If

            ' FAX
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_FaxNumber, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 6)
            End If

            ' ファイル名
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_FileName, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 7)
            End If

            ' ページ数
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Page, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 8)
            End If

            ' 通信速度
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_TermSpeed, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "2"
                        strWork = "2400bps"
                    Case "4"
                        strWork = "4800bps"
                    Case "7"
                        strWork = "7200bps(V.29)"
                    Case "9"
                        strWork = "9600bps(V.29)"
                    Case "A"
                        strWork = "7200bps(V.17)"
                    Case "B"
                        strWork = "9600bps(V.17)"
                    Case "C"
                        strWork = "12000bps"
                    Case "E"
                        strWork = "14400bps"
                    Case "G"
                        strWork = "16800bps"
                    Case "H"
                        strWork = "19200bps"
                    Case "I"
                        strWork = "21600bps"
                    Case "J"
                        strWork = "24000bps"
                    Case "K"
                        strWork = "26400bps"
                    Case "L"
                        strWork = "28800bps"
                    Case "M"
                        strWork = "31200bps"
                    Case "N"
                        strWork = "33600bps"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 9)
            End If

            ' 通信時間
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_TotalTime, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 10)
            End If

            ' 画品質
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_TermReso, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "N"
                        strWork = "ノーマル"
                    Case "F"
                        strWork = "ファイン"
                    Case "S"
                        strWork = "スーパーファイン"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 11)
            End If

            ' 符号化
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_TermComp, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "M"
                        strWork = "MMR"
                    Case "R"
                        strWork = "MR"
                    Case "H"
                        strWork = "MH"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 12)
            End If

            ' 用紙サイズ
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_TermSize, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "A"
                        strWork = "A4"
                    Case "B"
                        strWork = "B4"
                    Case CStr(3)
                        strWork = "A3"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 13)
            End If

            ' エラー訂正
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_TermECM, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "D"
                        strWork = "なし"
                    Case "E"
                        strWork = "ECM"
                    Case "S"
                        strWork = "ECM"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 14)
            End If

            ' 回線指定
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEMEX_LineDes, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "N"
                        strWork = "なし"
                    Case "0"
                        strWork = "回線１"
                    Case "1"
                        strWork = "回線２"
                    Case "2"
                        strWork = "回線３"
                    Case "3"
                        strWork = "回線４"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 15)
            End If

            ' 優先順位
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEMEX_Priority, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "N"
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 16)
            End If

            ' リトライ回数
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Retry, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 17)
            End If

            ' Ｆコード番号
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_FCode, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 18)
            End If

            ' パスワード
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Password, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 19)
            End If

            ' 会社名
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Company, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 20)
            End If

            ' 所属名
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Division, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 21)
            End If

            ' 役職名
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Position, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 22)
            End If

            ' 氏名
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Name, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 23)
            End If

            ' 郵便番号
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_ZipCode, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 24)
            End If

            ' 住所1
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Address1, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 25)
            End If

            ' 住所2
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Address2, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 26)
            End If

            ' 電話番号
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Telephone, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 27)
            End If

            ' FAX番号
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Fax, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 28)
            End If

            ' 敬称
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_Title, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 29)
            End If

            ' ユーザ使用
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_FreeArea, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 30)
            End If

            ' 記録位置
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_UserInfo, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 31)
            End If

            ' 自局電話番号
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_UserID, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 32)
            End If

            ' ジョブID
            If AxSFCSLogQue1.GetRecItemString(i, SFCSLOG_ITEM_JobID, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 33)
            End If

            Dim ListItem As ListViewItem = New ListViewItem(LstItems, -1)

            ListItem.ImageIndex = iImage

            Me.ListView.Items.Add(ListItem)

        Next

        Me.ListView.UseWaitCursor = False

    End Sub

    '-------------------------------------------------------------
    ' 送信ログの表示
    '-------------------------------------------------------------

    Private Sub ViewListViewSend()

        Dim iImage As Integer
        Dim i As Object

        InitLogColHeader()

        Me.ListView.UseWaitCursor = True

        '-------------------------------------------------------------
        ' ステータスバー表示

        Me.ToolStripStatusLabel.Text = "ログ件数:" & Str(AxSFCSLogSned1.GetRecCount())

        '/////////////////////////////////////////////////////////////
        '// 送信ログのリスト表示
        '//
        '// SFCSLogSendコントロール 《 送信ログのレコード数 取得 》
        '//   Function GetRecCount() as Long
        '//

        Dim strWork As String

        strWork = New String(Chr(0), 1025)

        For i = 0 To (AxSFCSLogSned1.GetRecCount() - 1)

            Dim LstItems() As String = {"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""}

            '/////////////////////////////////////////////////////////////
            '// 各項目の取得と表示
            '//
            '// SFCSLogQueコントロール 《 未送信ログのレコード項目 文字列取得 》
            '//   Function GetRecItemString( Rec As Long, Item As Integer,
            '//                              Get As String ) as Long
            '//

            ' 通信結果
            iImage = 3
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Return, strWork) = SFCSLOG_SUCCESS Then

                '/////////////////////////////////////////////////////////////
                '// 通信状態取得
                '//
                '// SFCSLogQueコントロール 《 未送信ログのレコード 通信状態取得 》
                '//   Function GetRecComStatus( Rec As Long,
                '//                             GetStatus As Long ) as Long
                '//

                ' 通信状態
                If strWork = "0" Then
                    iImage = 3
                    LstItems.SetValue("0", 0)
                Else
                    iImage = 4
                    LstItems.SetValue(strWork, 0)
                End If
            End If

            ' 日付/時刻
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Date, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 1)
            End If
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Time, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 2)
            End If

            ' 回線番号
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Line, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 3)
            End If

            ' アカウント
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Acount, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 4)
            End If

            ' 相手先
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_SendName, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 5)
            End If

            ' FAX
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_FaxNumber, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 6)
            End If

            ' ファイル名
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_FileName, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 7)
            End If

            ' ページ数
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Page, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 8)
            End If

            ' 通信速度
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_TermSpeed, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "2"
                        strWork = "2400bps"
                    Case "4"
                        strWork = "4800bps"
                    Case "7"
                        strWork = "7200bps(V.29)"
                    Case "9"
                        strWork = "9600bps(V.29)"
                    Case "A"
                        strWork = "7200bps(V.17)"
                    Case "B"
                        strWork = "9600bps(V.17)"
                    Case "C"
                        strWork = "12000bps"
                    Case "E"
                        strWork = "14400bps"
                    Case "G"
                        strWork = "16800bps"
                    Case "H"
                        strWork = "19200bps"
                    Case "I"
                        strWork = "21600bps"
                    Case "J"
                        strWork = "24000bps"
                    Case "K"
                        strWork = "26400bps"
                    Case "L"
                        strWork = "28800bps"
                    Case "M"
                        strWork = "31200bps"
                    Case "N"
                        strWork = "33600bps"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 9)
            End If

            ' 通信時間
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_TotalTime, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 10)
            End If

            ' 画品質
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_TermReso, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "N"
                        strWork = "ノーマル"
                    Case "F"
                        strWork = "ファイン"
                    Case "S"
                        strWork = "スーパーファイン"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 11)
            End If

            ' 符号化
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_TermComp, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "M"
                        strWork = "MMR"
                    Case "R"
                        strWork = "MR"
                    Case "H"
                        strWork = "MH"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 12)
            End If

            ' 用紙サイズ
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_TermSize, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "A"
                        strWork = "A4"
                    Case "B"
                        strWork = "B4"
                    Case CStr(3)
                        strWork = "A3"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 13)
            End If

            ' エラー訂正
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_TermECM, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "D"
                        strWork = "なし"
                    Case "E"
                        strWork = "ECM"
                    Case "S"
                        strWork = "ECM"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 14)
            End If

            ' 回線指定
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEMEX_LineDes, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "N"
                        strWork = "なし"
                    Case "0"
                        strWork = "回線１"
                    Case "1"
                        strWork = "回線２"
                    Case "2"
                        strWork = "回線３"
                    Case "3"
                        strWork = "回線４"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 15)
            End If

            ' 優先順位
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEMEX_Priority, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "N"
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 16)
            End If

            ' リトライ回数
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Retry, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 17)
            End If

            ' Ｆコード番号
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_FCode, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 18)
            End If

            ' パスワード
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Password, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 19)
            End If

            ' 会社名
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Company, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 20)
            End If

            ' 所属名
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Division, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 21)
            End If

            ' 役職名
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Position, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 22)
            End If

            ' 氏名
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Name, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 23)
            End If

            ' 郵便番号
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_ZipCode, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 24)
            End If

            ' 住所1
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Address1, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 25)
            End If

            ' 住所2
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Address2, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 26)
            End If

            ' 電話番号
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Telephone, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 27)
            End If

            ' FAX番号
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Fax, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 28)
            End If

            ' 敬称
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_Title, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 29)
            End If

            ' ユーザ使用
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_FreeArea, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 30)
            End If

            ' 記録位置
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_UserInfo, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 31)
            End If

            ' 自局電話番号
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_UserID, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 32)
            End If

            ' ジョブID
            If AxSFCSLogSned1.GetRecItemString(i, SFCSLOG_ITEM_JobID, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 33)
            End If

            Dim ListItem As ListViewItem = New ListViewItem(LstItems, -1)

            ListItem.ImageIndex = iImage

            Me.ListView.Items.Add(ListItem)

        Next

        Me.ListView.UseWaitCursor = False
    End Sub

    '-------------------------------------------------------------
    ' 受信ログの表示
    '-------------------------------------------------------------

    Private Sub ViewListViewRecv()

        Dim iImage As Integer
        Dim i As Object

        InitLogColHeader()

        Me.ListView.UseWaitCursor = True

        '-------------------------------------------------------------
        ' ステータスバー表示

        Me.ToolStripStatusLabel.Text = "ログ件数:" & Str(AxSFCSLogRecv1.GetRecCount())

        '/////////////////////////////////////////////////////////////
        '// 受信ログのリスト表示
        '//
        '// SFCSLogRecvコントロール 《 受信ログのレコード数 取得 》
        '//   Function GetRecCount() as Long
        '//

        Dim strWork As String

        strWork = New String(Chr(0), 1025)

        For i = 0 To (AxSFCSLogRecv1.GetRecCount() - 1)

            Dim LstItems() As String = {"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""}

            '/////////////////////////////////////////////////////////////
            '// 各項目の取得と表示
            '//
            '// SFCSLogQueコントロール 《 未送信ログのレコード項目 文字列取得 》
            '//   Function GetRecItemString( Rec As Long, Item As Integer,
            '//                              Get As String ) as Long
            '//

            ' 通信結果
            iImage = 3
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Return, strWork) = SFCSLOG_SUCCESS Then

                '/////////////////////////////////////////////////////////////
                '// 通信状態取得
                '//
                '// SFCSLogQueコントロール 《 未送信ログのレコード 通信状態取得 》
                '//   Function GetRecComStatus( Rec As Long,
                '//                             GetStatus As Long ) as Long
                '//

                ' 通信状態
                If strWork = "0" Then
                    iImage = 3
                    LstItems.SetValue("0", 0)
                Else
                    iImage = 4
                    LstItems.SetValue(strWork, 0)
                End If
            End If

            ' 日付/時刻
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Date, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 1)
            End If
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Time, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 2)
            End If

            ' 回線番号
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Line, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 3)
            End If

            ' アカウント
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Acount, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 4)
            End If

            ' 相手先
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_SendName, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 5)
            End If

            ' FAX
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_FaxNumber, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 6)
            End If

            ' ファイル名
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_FileName, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 7)
            End If

            ' ページ数
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Page, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 8)
            End If

            ' 通信速度
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_TermSpeed, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "2"
                        strWork = "2400bps"
                    Case "4"
                        strWork = "4800bps"
                    Case "7"
                        strWork = "7200bps(V.29)"
                    Case "9"
                        strWork = "9600bps(V.29)"
                    Case "A"
                        strWork = "7200bps(V.17)"
                    Case "B"
                        strWork = "9600bps(V.17)"
                    Case "C"
                        strWork = "12000bps"
                    Case "E"
                        strWork = "14400bps"
                    Case "G"
                        strWork = "16800bps"
                    Case "H"
                        strWork = "19200bps"
                    Case "I"
                        strWork = "21600bps"
                    Case "J"
                        strWork = "24000bps"
                    Case "K"
                        strWork = "26400bps"
                    Case "L"
                        strWork = "28800bps"
                    Case "M"
                        strWork = "31200bps"
                    Case "N"
                        strWork = "33600bps"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 9)
            End If

            ' 通信時間
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_TotalTime, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 10)
            End If

            ' 画品質
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_TermReso, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "N"
                        strWork = "ノーマル"
                    Case "F"
                        strWork = "ファイン"
                    Case "S"
                        strWork = "スーパーファイン"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 11)
            End If

            ' 符号化
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_TermComp, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "M"
                        strWork = "MMR"
                    Case "R"
                        strWork = "MR"
                    Case "H"
                        strWork = "MH"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 12)
            End If

            ' 用紙サイズ
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_TermSize, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "A"
                        strWork = "A4"
                    Case "B"
                        strWork = "B4"
                    Case CStr(3)
                        strWork = "A3"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 13)
            End If

            ' エラー訂正
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_TermECM, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "D"
                        strWork = "なし"
                    Case "E"
                        strWork = "ECM"
                    Case "S"
                        strWork = "ECM"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 14)
            End If

            ' 回線指定
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEMEX_LineDes, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "N"
                        strWork = "なし"
                    Case "0"
                        strWork = "回線１"
                    Case "1"
                        strWork = "回線２"
                    Case "2"
                        strWork = "回線３"
                    Case "3"
                        strWork = "回線４"
                    Case Else
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 15)
            End If

            ' 優先順位
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEMEX_Priority, strWork) = SFCSLOG_SUCCESS Then
                Select Case strWork
                    Case "N"
                        strWork = ""
                End Select
                LstItems.SetValue(strWork, 16)
            End If

            ' リトライ回数
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Retry, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 17)
            End If

            ' Ｆコード番号
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_FCode, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 18)
            End If

            ' パスワード
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Password, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 19)
            End If

            ' 会社名
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Company, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 20)
            End If

            ' 所属名
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Division, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 21)
            End If

            ' 役職名
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Position, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 22)
            End If

            ' 氏名
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Name, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 23)
            End If

            ' 郵便番号
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_ZipCode, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 24)
            End If

            ' 住所1
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Address1, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 25)
            End If

            ' 住所2
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Address2, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 26)
            End If

            ' 電話番号
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Telephone, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 27)
            End If

            ' FAX番号
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Fax, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 28)
            End If

            ' 敬称
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_Title, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 29)
            End If

            ' ユーザ使用
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_FreeArea, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 30)
            End If

            ' 記録位置
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_UserInfo, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 31)
            End If

            ' 自局電話番号
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_UserID, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 32)
            End If

            ' ジョブID
            If AxSFCSLogRecv1.GetRecItemString(i, SFCSLOG_ITEM_JobID, strWork) = SFCSLOG_SUCCESS Then
                LstItems.SetValue(strWork, 33)
            End If

            Dim ListItem As ListViewItem = New ListViewItem(LstItems, -1)

            ListItem.ImageIndex = iImage

            Me.ListView.Items.Add(ListItem)

        Next

        Me.ListView.UseWaitCursor = False
    End Sub

    '*************************************************************
    ' リストビュー: マウスが押された
    '*************************************************************

    Private Sub ListView_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ListView.MouseDown

        ' 右クリックを取得
        If e.Button = MouseButtons.Right Then
            s_iMouseClickMode = s_cstMouseClickMode_RightClick
        End If

    End Sub

    '*************************************************************
    ' リストビュー: マウスが離された
    '*************************************************************

    Private Sub ListView_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ListView.MouseUp

        ' マウス状態クリア
        s_iMouseClickMode = s_cstMouseClickMode_Non

    End Sub

    '*************************************************************
    ' リストビュー: ダブルクリック
    '*************************************************************

    Private Sub ListView_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ListView.MouseDoubleClick

        ' ダブルクリックを取得
        Dim liList As System.Windows.Forms.ListViewHitTestInfo
        Dim pointMouse As System.Drawing.Point

        pointMouse.X = e.X
        pointMouse.Y = e.Y
        liList = ListView.HitTest(pointMouse)

        If Not liList Is Nothing Then

            If Me.TreeView.SelectedNode.Tag = TREE_SELECT_TYPE_LOG Then

                ' ログ選択モードのとき
                If liList.Item.Text = "未送信" Then
                    FocusNodePosition("未送信")
                ElseIf liList.Item.Text = "送信" Then
                    FocusNodePosition("送信")
                ElseIf liList.Item.Text = "受信" Then
                    FocusNodePosition("受信")
                End If

            Else
                mnuActionView() ' ビューア呼び出し
            End If

        End If

    End Sub

    '-------------------------------------------------------------
    ' ツリービューの指定ノードを選択状態に
    '-------------------------------------------------------------

    Private Sub FocusNodePosition(ByVal Text As String)

        Dim Node As TreeNode

        For Each Node In GetAllNodes(TreeView.Nodes)
            If Node.Text = Text Then
                TreeView.SelectedNode = Node
                TreeView.Focus() 'フォーカスがないと反転して表示されない。
                Exit For
            End If
        Next

    End Sub

    '-------------------------------------------------------------
    ' ツリービューのノードを取得
    '-------------------------------------------------------------

    Private Function GetAllNodes(ByVal Nodes As TreeNodeCollection) As ArrayList
        Dim Ar As New ArrayList
        Dim Node As TreeNode

        For Each Node In Nodes
            Ar.Add(Node)
            If Node.GetNodeCount(False) > 0 Then
                Ar.AddRange(GetAllNodes(Node.Nodes))
            End If
        Next

        Return Ar

    End Function

    '*************************************************************
    ' リストビュー: 項目クリック
    '*************************************************************

    Private Sub ListView_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListView.Click

        If Me.TreeView.SelectedNode.Tag <> TREE_SELECT_TYPE_LOG Then

            ' 右クリックのメニュー表示

            If s_iMouseClickMode = s_cstMouseClickMode_RightClick Then

                Dim mnuContextMenu As New ContextMenu

                ' 位置を取得
                Dim pointMouse As POINTAPI
                Dim lGCP As Object
                Dim lSTC As Integer
                lGCP = GetCursorPos(pointMouse)
                lSTC = ScreenToClient(ListView.Parent.Parent.Handle.ToInt32, pointMouse)
                MenuStrip1.ContextMenu = mnuContextMenu
                MenuStrip1.ContextMenu.MenuItems.Add(New System.Windows.Forms.MenuItem("ビューア （&V）", New EventHandler(AddressOf Me.PopViwerToolStripMenuItem_Click)))
                MenuStrip1.ContextMenu.MenuItems.Add(New System.Windows.Forms.MenuItem("削除 （&D）", New EventHandler(AddressOf Me.PopDelToolStripMenuItem_Click)))

                'ポップアップメニューの表示
                MenuStrip1.ContextMenu.Show(Me, New System.Drawing.Point(pointMouse.x, pointMouse.y))
            End If

        End If

    End Sub

    '-------------------------------------------------------------
    ' Implements the manual sorting of items by columns.
    '-------------------------------------------------------------

    Class ListViewItemComparer
        Implements IComparer

        Private col As Integer
        Private so As System.Windows.Forms.SortOrder

        Public Sub New()
            col = 0
        End Sub

        Public Sub New(ByVal column As Integer)
            col = column
        End Sub

        Public Sub New(ByVal column As Integer, ByVal sortorder As Integer)
            col = column
            so = sortorder
        End Sub

        Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer _
           Implements IComparer.Compare
            If so = SortOrder.Ascending Then
                Return [String].Compare(CType(x, ListViewItem).SubItems(col).Text, CType(y, ListViewItem).SubItems(col).Text)
            Else
                Return [String].Compare(CType(y, ListViewItem).SubItems(col).Text, CType(x, ListViewItem).SubItems(col).Text)
            End If
        End Function
    End Class

    '*************************************************************
    ' リストビュー: ヘッダクリック
    '*************************************************************

    Private Sub ListView_ColumnClick(ByVal sender As Object, ByVal e As System.Windows.Forms.ColumnClickEventArgs) Handles ListView.ColumnClick

        If Me.TreeView.SelectedNode.Tag <> TREE_SELECT_TYPE_LOG Then

            ' Figure out the new sorting order.
            Dim sort_order As System.Windows.Forms.SortOrder

            If s_bListViewSort Then
                sort_order = SortOrder.Ascending
                s_bListViewSort = False
            Else
                sort_order = SortOrder.Descending
                s_bListViewSort = True
            End If

            ' Create a comparer.
            ListView.ListViewItemSorter = New ListViewItemComparer(e.Column, sort_order)

            ' Sort.
            ListView.Sort()

        End If

    End Sub

    '*************************************************************
    ' ツールバー: 更新
    '*************************************************************

    Private Sub UpdateToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UpdateToolStripButton.Click

        mnuActionUpdate()   ' 最新の情報に更新

    End Sub

    '*************************************************************
    ' ツールバー: ビューア
    '*************************************************************

    Private Sub ViewToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ViewToolStripButton.Click

        mnuActionView() ' ビューア呼び出し

    End Sub

    '*************************************************************
    ' ツールバー: バージョン情報
    '*************************************************************

    Private Sub AboutToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripButton.Click

        AboutDlg.ShowDialog()

    End Sub

    '*************************************************************
    ' 右クリックメニュー: ビューア
    '*************************************************************

    Private Sub PopViwerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PopViwerToolStripMenuItem.Click

        mnuActionView() ' ビューア呼び出し

    End Sub

    '*************************************************************
    ' 右クリックメニュー: 削除
    '*************************************************************

    Private Sub PopDelToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PopDelToolStripMenuItem.Click

        mnuActionDelete() ' 削除処理

    End Sub

    '*************************************************************
    ' 操作メニュー: 最新の情報に更新
    '*************************************************************

    Private Sub UpdateToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UpdateToolStripMenuItem.Click

        mnuActionUpdate()   ' 最新の情報に更新

    End Sub

    '*************************************************************
    ' 操作メニュー: FAX情報表示の終了
    '*************************************************************

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click

        'このフォームを閉じます
        Me.Close()

    End Sub

    '*************************************************************
    ' 編集メニュー: 削除
    '*************************************************************

    Private Sub DelToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DelToolStripMenuItem.Click

        mnuActionDelete() ' 削除処理

    End Sub

    '*************************************************************
    ' 表示メニュー: ツールバー
    '*************************************************************

    Private Sub ToolBarToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolBarToolStripMenuItem.Click

        'toolstrip の表示状態および関連メニュー項目のチェック状態を切り替えます
        ToolBarToolStripMenuItem.Checked = Not ToolBarToolStripMenuItem.Checked
        ToolStrip.Visible = ToolBarToolStripMenuItem.Checked

    End Sub

    '*************************************************************
    ' 表示メニュー: ステータスバー
    '*************************************************************

    Private Sub StatusBarToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StatusBarToolStripMenuItem.Click

        'statusstrip の表示状態および関連メニュー項目のチェック状態を切り替えます
        StatusBarToolStripMenuItem.Checked = Not StatusBarToolStripMenuItem.Checked
        StatusStrip.Visible = StatusBarToolStripMenuItem.Checked

    End Sub

    '*************************************************************
    ' ツールメニュー: ビューア
    '*************************************************************

    Private Sub ViewerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ViewerToolStripMenuItem.Click

        mnuActionView() ' ビューア呼び出し

    End Sub

    '*************************************************************
    ' ヘルプメニュー: クリック
    '*************************************************************

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click

        AboutDlg.ShowDialog()

    End Sub

    '-------------------------------------------------------------
    ' ビューア呼び出し
    '-------------------------------------------------------------

    Private Sub mnuActionView()

        If Me.TreeView.SelectedNode.Tag <> TREE_SELECT_TYPE_LOG Then

            Dim strFilePath As String
            Dim strViewExeName, strViewComand As Object
            Dim strViewPath As String
            Dim strInstall As String

            '/////////////////////////////////////////////////////////////
            '// ビューア呼び出し

            Dim SelectedItems As ListView.SelectedListViewItemCollection = Me.ListView.SelectedItems
            If SelectedItems.Count() = 0 Then
                Exit Sub
            End If

            strInstall = New String(Chr(0), 161)

            If AxSFCSEnv1.GetSfcsFolder(strInstall) = SFCSENV_SUCCESS Then

                strFilePath = SelectedItems.Item(0).SubItems(7).Text

                strViewExeName = "\SfCsVw.exe"
                strViewComand = " /Tビューア "
                strViewPath = Chr(34) & strInstall & strViewExeName & Chr(34) & strViewComand & Chr(34) & strFilePath & Chr(34)
                Call Shell(strViewPath, AppWinStyle.NormalFocus)
            End If

        End If

    End Sub

    '-------------------------------------------------------------
    ' ビューアメニュー、削除メニューをDisable
    '-------------------------------------------------------------

    Private Sub mnuActionDisable()

        If Me.TreeView.SelectedNode.Tag = TREE_SELECT_TYPE_LOG Then
            UpdateToolStripButton.Enabled = False
            ViewToolStripButton.Enabled = False
            UpdateToolStripMenuItem.Enabled = False
            DelToolStripMenuItem.Enabled = False
            ViewerToolStripMenuItem.Enabled = False
        Else
            UpdateToolStripButton.Enabled = True
            ViewToolStripButton.Enabled = True
            UpdateToolStripMenuItem.Enabled = True
            DelToolStripMenuItem.Enabled = True
            ViewerToolStripMenuItem.Enabled = True
        End If
    End Sub

    '-------------------------------------------------------------
    ' 最新の情報に更新
    '-------------------------------------------------------------

    Private Sub mnuActionUpdate()

        If Me.TreeView.SelectedNode.Tag = TREE_SELECT_TYPE_LOG Then
            Exit Sub
        End If

        If Me.TreeView.SelectedNode.Tag = TREE_SELECT_TYPE_SEND_BEFORE Then


            '/////////////////////////////////////////////////////////////
            '// 未送信ログの再読み込み
            '//
            '// SFCSLogQueコントロール 《 未送信ログの再読み込み 》
            '//   Function Reload( Dlg As Integer ) as Long
            '//

            AxSFCSLogQue1.Reload(SFCSLOG_Dialog_TRUE)

        ElseIf Me.TreeView.SelectedNode.Tag = TREE_SELECT_TYPE_SEND_AFTER Then

            '/////////////////////////////////////////////////////////////
            '// 送信ログの再読み込み
            '//
            '// SFCSLogSendコントロール 《 送信ログの再読み込み 》
            '//   Function Reload( Dlg As Integer ) as Long
            '//

            AxSFCSLogSned1.Reload(SFCSLOG_Dialog_TRUE)

        ElseIf Me.TreeView.SelectedNode.Tag = TREE_SELECT_TYPE_RECEIVE Then

            '/////////////////////////////////////////////////////////////
            '// 受信ログの再読み込み
            '//
            '// SFCSLogSendコントロール 《 受信ログの再読み込み 》
            '//   Function Reload( Dlg As Integer ) as Long
            '//

            AxSFCSLogRecv1.Reload(SFCSLOG_Dialog_TRUE)

        End If

        SetListView(Me.TreeView.SelectedNode.Tag)

    End Sub

    '-------------------------------------------------------------
    ' 削除処理
    '-------------------------------------------------------------

    Private Sub mnuActionDelete()

        Dim iResponse As Short

        Select Case Me.TreeView.SelectedNode.Tag
            Case TREE_SELECT_TYPE_SEND_BEFORE
                iResponse = MsgBox("選択された 未送信情報 を削除してよろしいですか？", MsgBoxStyle.OkCancel + MsgBoxStyle.Exclamation + MsgBoxStyle.DefaultButton2, g_cstTITLE)
                If iResponse = MsgBoxResult.Ok Then
                    DeleteQue()
                End If
            Case TREE_SELECT_TYPE_SEND_AFTER
                iResponse = MsgBox("選択された 送信情報 を削除してよろしいですか？", MsgBoxStyle.OkCancel + MsgBoxStyle.Exclamation + MsgBoxStyle.DefaultButton2, g_cstTITLE)
                If iResponse = MsgBoxResult.Ok Then
                    DeleteSend()
                End If
            Case TREE_SELECT_TYPE_RECEIVE
                iResponse = MsgBox("選択された 受信情報 を削除してよろしいですか？", MsgBoxStyle.OkCancel + MsgBoxStyle.Exclamation + MsgBoxStyle.DefaultButton2, g_cstTITLE)
                If iResponse = MsgBoxResult.Ok Then
                    DeleteRecv()
                End If
        End Select

    End Sub

    '-------------------------------------------------------------
    ' 未送信情報削除命令ファイル作成
    '-------------------------------------------------------------

    Private Sub DeleteQue()

        Dim strDeletItem As String

        If Me.ListView.Items.Count <> 0 Then

            Dim SelectedItems As ListView.SelectedListViewItemCollection = Me.ListView.SelectedItems
            Dim item As ListViewItem

            '/////////////////////////////////////////////////////////////
            '// 削除情報の初期化
            '//
            '// SFCSLogQueコントロール 《 削除ジョブIDリスト リセット 》
            '//   Sub ResetDocInfo()
            '//

            AxSFCSLogQue1.ResetDelInfo()

            For Each item In SelectedItems

                strDeletItem = item.SubItems(33).Text

                '/////////////////////////////////////////////////////////////
                '// 削除情報の追加
                '//
                '// SFCSLogQueコントロール 《 削除ジョブIDリスト 追加設定 》
                '//   Function AddDelInfo( JobID As String ) as Long
                '//

                Call AxSFCSLogQue1.AddDelInfo(strDeletItem)

            Next

            '/////////////////////////////////////////////////////////////
            '// 削除命令ファイル作成
            '//
            '// SFCSLogQueコントロール 《 未送信情報削除命令ファイル作成 》
            '//   Function MakeDelMission() as Long
            '//

            Call AxSFCSLogQue1.MakeDelMission()

        End If

    End Sub

    '-------------------------------------------------------------
    ' 送信情報削除命令ファイル作成
    '-------------------------------------------------------------

    Private Sub DeleteSend()

        Dim strDeletItem As String

        If Me.ListView.Items.Count <> 0 Then

            Dim SelectedItems As ListView.SelectedListViewItemCollection = Me.ListView.SelectedItems
            Dim item As ListViewItem

            '/////////////////////////////////////////////////////////////
            '// 削除情報の初期化
            '//
            '// SFCSLogSendコントロール 《 削除ジョブIDリスト リセット 》
            '//   Sub ResetDocInfo()
            '//

            AxSFCSLogSned1.ResetDelInfo()

            For Each item In SelectedItems

                strDeletItem = item.SubItems(33).Text

                '/////////////////////////////////////////////////////////////
                '// 削除情報の追加
                '//
                '// SFCSLogSendコントロール 《 削除ジョブIDリスト 追加設定 》
                '//   Function AddDelInfo( JobID As String ) as Long
                '//

                Call AxSFCSLogSned1.AddDelInfo(strDeletItem)

            Next

            '/////////////////////////////////////////////////////////////
            '// 削除命令ファイル作成
            '//
            '// SFCSLogSendコントロール 《 送信情報削除命令ファイル作成 》
            '//   Function MakeDelMission() as Long
            '//

            Call AxSFCSLogSned1.MakeDelMission()

        End If

    End Sub

    '-------------------------------------------------------------
    ' 受信情報削除命令ファイル作成
    '-------------------------------------------------------------

    Private Sub DeleteRecv()

        Dim strDeletItem As String

        If Me.ListView.Items.Count <> 0 Then

            Dim SelectedItems As ListView.SelectedListViewItemCollection = Me.ListView.SelectedItems
            Dim item As ListViewItem

            '/////////////////////////////////////////////////////////////
            '// 削除情報の初期化
            '//
            '// SFCSLogRecvコントロール 《 削除ジョブIDリスト リセット 》
            '//   Sub ResetDocInfo()
            '//

            AxSFCSLogRecv1.ResetDelInfo()

            For Each item In SelectedItems

                strDeletItem = item.SubItems(33).Text

                '/////////////////////////////////////////////////////////////
                '// 削除情報の追加
                '//
                '// SFCSLogRecvコントロール 《 削除ジョブIDリスト 追加設定 》
                '//   Function AddDelInfo( JobID As String ) as Long
                '//

                Call AxSFCSLogRecv1.AddDelInfo(strDeletItem)

            Next

            '/////////////////////////////////////////////////////////////
            '// 削除命令ファイル作成
            '//
            '// SFCSLogRecvコントロール 《 受信情報削除命令ファイル作成 》
            '//   Function MakeDelMission() as Long
            '//

            Call AxSFCSLogRecv1.MakeDelMission()

        End If

    End Sub

End Class
