// SFTreeView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "MonLog.h"
#include "SFTreeView.h"
#include "MonLogDoc.h"
#include "MainFrm.h"

#include "SFListView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// 萔`

// Image indexes
#define SF_ILI_LOG				0
#define SF_ILI_OPEN_FOLDER		1
#define	SF_ILI_CLOSED_FOLDER	2

/////////////////////////////////////////////////////////////////////////////
// CSFTreeView

IMPLEMENT_DYNCREATE(CSFTreeView, CTreeView)

/////////////////////////////////////////////////////////////////////////////
// 

CSFTreeView::CSFTreeView()
{
}

/////////////////////////////////////////////////////////////////////////////
// 

CSFTreeView::~CSFTreeView()
{
}

BEGIN_MESSAGE_MAP(CSFTreeView, CTreeView)
	//{{AFX_MSG_MAP(CSFTreeView)
	ON_WM_CREATE()
	ON_NOTIFY_REFLECT(TVN_ITEMEXPANDING, OnItemexpanding)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnSelchanged)
	ON_COMMAND(ID_OPE_UPDATE, OnOpeUpdate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// 

BOOL CSFTreeView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB
    cs.style |= TVS_HASLINES | TVS_HASBUTTONS | TVS_SHOWSELALWAYS;

	return CTreeView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSFTreeView `

void CSFTreeView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: ̈ʒuɕ`p̃R[hǉĂ
}

/////////////////////////////////////////////////////////////////////////////
// 

void CSFTreeView::OnInitialUpdate()
{
	CTreeView::OnInitialUpdate();

	// TODO:  GetTreeCtrl() o֐̌ĂяoʂĒڂ̃Xg Rg[
	//  ANZX邱Ƃɂ TreeView ACeŌŒł܂B
}

/////////////////////////////////////////////////////////////////////////////
// CSFTreeView ff

#ifdef _DEBUG
void CSFTreeView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CSFTreeView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}

CMonLogDoc* CSFTreeView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMonLogDoc)));
	return (CMonLogDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSFTreeView bZ[W nh

int CSFTreeView::OnCreate( LPCREATESTRUCT lpCreateStruct ) 
{
	if( CTreeView::OnCreate( lpCreateStruct ) == -1 )
		return -1;
	
	m_imglDrives.Create( IDB_TREEIMAGES, 16, 1, RGB( 255, 255, 255 ) );
	GetTreeCtrl().SetImageList( &m_imglDrives, TVSIL_NORMAL );

	InitTree();
	
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// c[WJ

void CSFTreeView::OnItemexpanding( NMHDR* pNMHDR, LRESULT* pResult ) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	HTREEITEM hItem = pNMTreeView->itemNew.hItem;
	CString string = GetPathFromNode( hItem );

	*pResult = FALSE;

	if( pNMTreeView->action == TVE_EXPAND ) {
		DeleteAllChildren( hItem );
		if( AddDirectories( hItem, string ) == 0 ) {
			*pResult = TRUE;
		}
	}
	else {	// pnmtv->action == TVE_COLLAPSE
		DeleteAllChildren( hItem );
		if( GetTreeCtrl().GetParentItem( hItem ) == NULL ) {
			GetTreeCtrl().InsertItem( "", SF_ILI_CLOSED_FOLDER, SF_ILI_OPEN_FOLDER, hItem );
		}
		else {
			SetButtonState( hItem, string );
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// IύX

void CSFTreeView::OnSelchanged( NMHDR* pNMHDR, LRESULT* pResult ) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	::EnterCriticalSection( &((CMonLogDoc *)GetDocument())->m_CS_CurList );
	if( ((CMonLogDoc *)GetDocument())->m_dwCurList != SFLIST_NONE ) {
		((CMonLogDoc *)GetDocument())->m_dwCurList = SFLIST_NONE;
		::LeaveCriticalSection( &((CMonLogDoc *)GetDocument())->m_CS_CurList );
		CSFListView*	pList = ((CMonLogDoc *)GetDocument())->GetListView();
		if( pList ) {
			pList->ResetListView();
		}
	}
	else {
		::LeaveCriticalSection( &((CMonLogDoc *)GetDocument())->m_CS_CurList );
	}

	CString	strPath = GetPathFromNode( pNMTreeView->itemNew.hItem );

	OnSelectionChanged( strPath );

	*pResult = 0;
}

/////////////////////////////////////////////////////////////////////////////
// IύX

void CSFTreeView::OnSelectionChanged( CString& strPath, BOOL bSelect )
{
    //
    // Override this function in a derived class to respond to
    // selection changes differently. Here, UpdateAllViews is used
    // as a conduit for updating the companion CFileView.
    //

	if( bSelect ) {
		if( HTREEITEM hRootItem = GetTreeCtrl().GetRootItem() ) {

			HTREEITEM	hItem;
			CString	csRoot = "O";

			hItem = hRootItem;

			if( strPath.Find( "O\\" ) == 0 ) {

				CString	csDel = "O";

				DeleteAllChildren( hItem );
				AddDirectories( hItem, csDel );
				GetTreeCtrl().Expand( hItem, TVE_EXPAND );

				hItem = GetTreeCtrl().GetChildItem( hItem );
				if( strPath != "O\\M" ) {
					hItem = GetTreeCtrl().GetNextSiblingItem( hItem );
					if( strPath != "O\\M" ) {
						hItem = GetTreeCtrl().GetNextSiblingItem( hItem );
					}
				}
			}
			else {

				TVITEM	TvItem; 
				CString	csAdd = "O";

				ZeroMemory( &TvItem, sizeof(TVITEM) );
				TvItem.mask = TVIF_STATE;
				TvItem.hItem = hItem;
				TvItem.stateMask = TVIS_EXPANDED;
				GetTreeCtrl().GetItem( &TvItem );

				DeleteAllChildren( hItem );
				AddDirectories( hItem, csAdd );
				GetTreeCtrl().Expand( hItem, TVE_EXPAND );

				if( !(TvItem.state & TVIS_EXPANDED) ) {
					GetTreeCtrl().Expand( hItem, TVE_COLLAPSE );
				}
			}
			GetTreeCtrl().SelectItem( hItem );
		}
	}
	else {
		::EnterCriticalSection( &((CMonLogDoc *)GetDocument())->m_CS_CurList );
		if( ((CMonLogDoc *)GetDocument())->m_dwCurList != SFLIST_NONE ) {
			((CMonLogDoc *)GetDocument())->m_dwCurList = SFLIST_NONE;
			::LeaveCriticalSection( &((CMonLogDoc *)GetDocument())->m_CS_CurList );
			CSFListView*	pList = ((CMonLogDoc *)GetDocument())->GetListView();
			if( pList ) {
				pList->ResetListView();
			}
		}
		else {
			::LeaveCriticalSection( &((CMonLogDoc *)GetDocument())->m_CS_CurList );
		}

		::EnterCriticalSection( &((CMonLogDoc *)GetDocument())->m_CS_CurList );
		if( strPath == "O" ) {
			((CMonLogDoc *)GetDocument())->m_dwCurList = SFLIST_LOG;
		}
		else if( strPath == "O\\M" ) {
			((CMonLogDoc *)GetDocument())->m_dwCurList = SFLIST_QUE;
		}
		else if( strPath == "O\\M" ) {
			((CMonLogDoc *)GetDocument())->m_dwCurList = SFLIST_SEND;
		}
		else if( strPath == "O\\M" ) {
			((CMonLogDoc *)GetDocument())->m_dwCurList = SFLIST_RECV;
		}
		::LeaveCriticalSection( &((CMonLogDoc *)GetDocument())->m_CS_CurList );

		GetDocument()->UpdateAllViews( this, (LPARAM)(LPCTSTR)strPath );
	}
}

/////////////////////////////////////////////////////////////////////////////
// c[\

int CSFTreeView::InitTree( void )
{
	AddRootNode();

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// c[̃ACeǉ

BOOL CSFTreeView::AddRootNode( void )
{
	CString	string;
	HTREEITEM	hItem;

	CString	strRoot = "O";

	static BOOL	s_bFirst = TRUE;

	hItem = GetTreeCtrl().InsertItem( strRoot, SF_ILI_CLOSED_FOLDER, SF_ILI_OPEN_FOLDER, TVI_ROOT, TVI_LAST );

	SetButtonState( hItem, strRoot );

	// If this is the first fixed disk, select and expand it
	if( s_bFirst ) {

		HTREEITEM	hChildItem;
		HTREEITEM	hNextSiblingItem;

		GetTreeCtrl().SelectItem( hItem );
		GetTreeCtrl().Expand( hItem, TVE_EXPAND );
		GetTreeCtrl().Expand( hChildItem = GetTreeCtrl().GetChildItem( hItem ), TVE_EXPAND );
		GetTreeCtrl().Expand( hNextSiblingItem = GetTreeCtrl().GetNextSiblingItem( hChildItem ), TVE_EXPAND );
		s_bFirst = FALSE;
	}

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// c[ACȇ

BOOL CSFTreeView::SetButtonState( HTREEITEM hItem, CString& strPath )
{
	BOOL bResult = FALSE;

	GetTreeCtrl().InsertItem( "", SF_ILI_CLOSED_FOLDER, SF_ILI_OPEN_FOLDER, hItem );
	bResult = TRUE;

	return bResult;
}

/////////////////////////////////////////////////////////////////////////////
// c[ACẽpXl

CString CSFTreeView::GetPathFromNode( HTREEITEM hItem )
{
	CString	strResult = GetTreeCtrl().GetItemText( hItem );

	HTREEITEM	hParent;

	while( ( hParent = GetTreeCtrl().GetParentItem( hItem ) ) != NULL ) {

		CString	string = GetTreeCtrl().GetItemText( hParent );

		if( string.Right (1) != "\\" )
			string += "\\";
		strResult = string + strResult;
		hItem = hParent;
	}

	return strResult;
}

/////////////////////////////////////////////////////////////////////////////
// c[ACẽpXǉ

int CSFTreeView::AddDirectories( HTREEITEM hItem, CString& strPath )
{
	HTREEITEM hNewItem;

	CString	szLog[3] = { _T("M"), _T("M"), _T("M") };

	int	i;

	int	nCount = 0;

	CString	strAdd;
	CString	strNewPath;

	if( strPath == "O" ) {
		// uOv̏ꍇ

		for( i = 0 ; i < 3 ; i++ ) {

			hNewItem = GetTreeCtrl().InsertItem( (LPCTSTR)szLog[i], SF_ILI_LOG, SF_ILI_LOG, hItem );
			strNewPath = strPath;
			if( strNewPath.Right( 1 ) != "\\" ) {
				strNewPath += "\\";
			}
			nCount++;
		}
	}

	return nCount;
}

/////////////////////////////////////////////////////////////////////////////
// ڔz̃ACe폜

void CSFTreeView::DeleteFirstChild( HTREEITEM hParent )
{
	HTREEITEM hItem;

	if( ( hItem = GetTreeCtrl().GetChildItem( hParent ) ) != NULL ) {
		GetTreeCtrl().DeleteItem( hItem );
	}
}

/////////////////////////////////////////////////////////////////////////////
// zׂẴACe폜

void CSFTreeView::DeleteAllChildren( HTREEITEM hParent )
{
	HTREEITEM	hItem;

	if( ( hItem = GetTreeCtrl().GetChildItem( hParent ) ) == NULL )
		return;

	do {
		HTREEITEM hNextItem = GetTreeCtrl().GetNextSiblingItem (hItem);
		GetTreeCtrl ().DeleteItem (hItem);
		hItem = hNextItem;
	} while( hItem != NULL );
}

////////////////////////////////////////////////////////////////////////////////////
// 

void CSFTreeView::UpdateDisplay()
{
	HTREEITEM	hItem;

	if( hItem = GetTreeCtrl().GetSelectedItem() ) {
		CString strPath = GetPathFromNode( hItem );
		OnSelectionChanged( strPath );
	}
}

////////////////////////////////////////////////////////////////////////////////////
// 

void CSFTreeView::OnOpeUpdate() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	
	CMainFrame*	pMain = (CMainFrame*)((CMonLogApp*)AfxGetApp()->m_pMainWnd);

	if( pMain ) {
		pMain->OnOpeUpdate();
	}
}
